//*****************************************************************************
/// Edge_count.c

/// Company Name- Zera India Private limited.  
/// Author - Rajesh Varma
/// Date - 04/09/2017
/// Revision - 0

/// Remarks: Main loop consist of diffrent function implemented in switch case
///
//****************************************************************************
 
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "grlib/grlib.h"
#include "drivers/frame.h"
#include "drivers/kentec320x240x16_ssd2119.h"
#include "drivers/pinout.h"
#include "macros.h"
#include "extern_variables.h"




//*********************************************************************************************
///
/// void Edgecount_Page_Fix_Graphics(void)
///	I/p: Nothing
/// O/P: Noting
/// Remark: This function will display edgecount screen
//**********************************************************************************************

void Edgecount_Page_Fix_Graphics(void)
	{
		
		sRect_Label.i16XMin = 0;
		sRect_Label.i16YMin = 60;					
		sRect_Label.i16XMax = 314;
		sRect_Label.i16YMax = 180; 
		GrContextForegroundSet(&sContext_Label, BACKGROUND_COLOR);
		GrRectFill(&sContext_Label, &sRect_Label);
		
		sRect_Label.i16XMin = 150;
		sRect_Label.i16YMin = 205;					// Clean Display
		sRect_Label.i16XMax = 314;
		sRect_Label.i16YMax = 240; 
		GrContextForegroundSet(&sContext_Label, BACKGROUND_COLOR);
		GrRectFill(&sContext_Label, &sRect_Label);
		
		GrContextFontSet(&sContext_Label, &g_sFontCmss26b);
		GrContextForegroundSet(&sContext_Label, ClrWhite);
		GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
		GrContextForegroundSet(&sContext_Label, ClrRed);
		if(reset_count_flag)
		  GrStringDrawCentered(&sContext_Label,"Reset Count", -1,GrContextDpyWidthGet(&sContext_Label) / 2, 100, 0);
		else
			GrStringDrawCentered(&sContext_Label,"Edge Count", -1,GrContextDpyWidthGet(&sContext_Label) / 2, 100, 0);
		
		Flag.Edgecount_Screen=1;	
		Flag.Error_Screen = 0;
		memset(edge_buff,0x30,sizeof(edge_buff));
		edge_accuracy_switch=1;
			
	}
	
	


//*********************************************************************************************
///
/// void Edgecount_Page_Update(void)
///	I/p: Nothing
/// O/P: Noting
/// Remark: This function will display updated  edge count on screen
//**********************************************************************************************
void Edgecount_Page_Update(void)
{
	if (Flag.Data_Update == 1)
	{
		Flag.Data_Update = 0;
								
		GrContextFontSet(&sContext_Label, &g_sFontCmss48b);//g_sFontCmss72i		g_sFontCmss48b
		GrContextForegroundSet(&sContext_Label, ClrWhite);
		GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);
				
		if((once_display_hdlc==0)&&(transperent_mode==0))
		{
			if(reset_count_flag)
			{
				sprintf(pcBuffer, " %u ", reset_count); 
				sprintf(edge_buff, "%6d", reset_count); 
				GrStringDrawCentered(&sContext_Label,pcBuffer,-1,GrContextDpyWidthGet(&sContext_Label) / 2,153, 1);		
			}
			else
			{	
				if(Edge_count>999999){ Edge_count=0; C_Edge_count=0;}
				sprintf(pcBuffer, " %u ", (Edge_count*2)); 
				sprintf(edge_buff, "%6d", (C_Edge_count*2)); 
				
				GrStringDrawCentered(&sContext_Label,pcBuffer,-1,GrContextDpyWidthGet(&sContext_Label) / 2,153, 1);	
			}
		}
		
		GrContextFontSet(&sContext_Label, &g_sFontCmss22b);
		GrContextForegroundSet(&sContext_Label, ClrWhite);	   // for font colur
			
		if(SC_PULSE_Selection==0)
		{
			GrStringDraw(&sContext_Label, "SC     ", -1,20,210, 1);
			Clean_divide_display();
		}
		else
		{
			GrStringDraw(&sContext_Label, "PULSE", -1,20,210, 1);
			divide_display();
		}
					
	}
			
			
			
			
				
	if(reset_flag)
	{
		reset_flag=0;
		Edge_count=0;
		C_Edge_count=0;
		pulse_count=0;			//New added after observation
		sRect_Label.i16XMin = 0;
		sRect_Label.i16YMin = 130;					// previous value 0
		sRect_Label.i16XMax = 300;
		sRect_Label.i16YMax = 180; 
		GrContextForegroundSet(&sContext_Label, BACKGROUND_COLOR);
		GrRectFill(&sContext_Label, &sRect_Label);
									
				
	}

		  
	if(start_edge_flag)
	{
		
		start_edge_flag=0;
		Edge_mode_flag=1;
	//	Pulse_sense_interrupt();	// Load and Enable Timeer
		Flag.Start_Pressed=1;
		Flag.N_Actual_Ready=0;//Resettheflag
		timer_start_flag=1;
	}


		
}



void Timer_Reload(void)
{
	//TimerLoadSet(TIMER1_BASE,TIMER_A,0x0001);
	//TimerMatchSet(TIMER1_BASE,TIMER_A,0x0000); 
	//TimerEnable(TIMER1_BASE,TIMER_A);
	//IntEnable(INT_TIMER1A);
	//TimerIntEnable(TIMER1_BASE,TIMER_CAPA_MATCH);
	//IntMasterEnable();
}

void divide_display(void)
{
	GrLineDrawH(&sContext_Label, 240, 258,220);
	GrLineDrawH(&sContext_Label, 240, 258,221);
	GrStringDraw(&sContext_Label, "1000",-1,262,210, 1);
	GrCircleDraw(&sContext_Label,  249, 226,2);
	GrCircleFill(&sContext_Label,  249, 226,2);
	GrCircleDraw(&sContext_Label,  249, 215,2);
	GrCircleFill(&sContext_Label,  249, 215,2);
}

void Clean_divide_display(void)
{
   sRect_Label.i16XMin = 230;
   sRect_Label.i16YMin = 210;					
   sRect_Label.i16XMax = 310;
   sRect_Label.i16YMax = 230; 
   GrContextForegroundSet(&sContext_Label, BACKGROUND_COLOR);
   GrRectFill(&sContext_Label, &sRect_Label);

}
