//*****************************************************************************
/// Error_display.c

/// Company Name- Zera India Private limited.  
/// Author - Rajesh Varma
/// Date - 04/09/2017
/// Revision - 0

/// Remarks: Main loop consist of diffrent function implemented in switch case
///
//****************************************************************************
#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "grlib/grlib.h"
#include "drivers/frame.h"
#include "drivers/kentec320x240x16_ssd2119.h"
#include "drivers/pinout.h"
#include "macros.h"
#include "extern_variables.h"


float final_error;
int error_value;


//*********************************************************************************************
///
/// void Err_measure_Page_Fix_Graphics(void)
///	I/p: Nothing
/// O/P: Noting
/// Remark: This function will display error screen
//**********************************************************************************************

void Err_measure_Page_Fix_Graphics(void)
{
	Fix_Graphics();
	GrContextFontSet(&sContext_Label, &g_sFontCmss28b);
	GrContextForegroundSet(&sContext_Label, ClrWhite);
  	GrStringDraw(&sContext_Label, "POSITION", -1,90,17, 0);
	GrStringDraw(&sContext_Label, "-", -1, 215, 12, 0);
	sprintf(pcBuffer, "%d", atoi(Meter_Place.Slave_ID)); 
	Null_char_position(3,&pcBuffer[0]);
	GrStringDraw(&sContext_Label, pcBuffer, -1, 225,17, 0);
	
	GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
	GrContextForegroundSet(&sContext_Label, ClrRed);
	GrStringDrawCentered(&sContext_Label,"Error", -1,GrContextDpyWidthGet(&sContext_Label) / 2, 100, 0);
	
	
	GrContextInit(&sContext_Meas_set[0][0], &g_sKentec320x240x16_SSD2119); 
	sRect_Meas_set[0][0].i16XMin = 20;
	sRect_Meas_set[0][0].i16YMin = 176;
	sRect_Meas_set[0][0].i16XMax = 300;
	sRect_Meas_set[0][0].i16YMax = 204;


	Flag.Error_Screen = 1;
	Flag.Pulse_Received=0;
	if(edge_accuracy_switch)
	{
		Error_Display_Seq=1;
		edge_accuracy_switch=0;
	}
	else
	{
		Error_Display_Seq=0;
		
	}

}

//*********************************************************************************************
///
/// void Err_measure_Page_Update(void)
///	I/p: Nothing
/// O/P: Noting
/// Remark: This function will display updated  error screen
//**********************************************************************************************

void Err_measure_Page_Update(void)
{
	static unsigned char last_Error_Display_Seq;
		
	if(display_flag)
	{
		display_flag=0;
		Error_Display_Seq = Clean_Display;
		calculate_error();
		measurement_status_flag=3;
		Flag.Error_Displyed_Once = 1;
		Flag.Start_Pressed=1;
	}

	//if (Flag.Data_Update == 1)
	{
		Flag.Data_Update = 0;
			
		GrContextFontSet(&sContext_Label, &g_sFontCmss22b);
		GrContextForegroundSet(&sContext_Label, ClrWhite);	   // for font colur
		GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);
		if(single_flag)
		GrStringDraw(&sContext_Label, "        SINGLE", -1,170,210, 1);
		
		if(continuous_flag)
		GrStringDraw(&sContext_Label, "CONTINUOUS ", -1,170,210, 1);
			
		if(SC_PULSE_Selection==0)
			GrStringDraw(&sContext_Label, "SC     ", -1,20,210, 1);
		else
			GrStringDraw(&sContext_Label, "PULSE", -1,20,210, 1);
			
		GrContextFontSet(&sContext_Label, &g_sFontCmss12b);
		GrContextForegroundSet(&sContext_Label, ClrBlack);	  
		GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);
	
			
		if(Error_Display_Seq != last_Error_Display_Seq)
		{
			//	GrContextForegroundSet(&sContext_Meas_set[0][0], BACKGROUND_COLOR);
		    //	GrRectFill(&sContext_Meas_set[0][0], &sRect_Meas_set[0][0]);		 //Keep last error value
		}

		

			switch (Error_Display_Seq)
			{
				case 0:
						if((DLMS_Read_Flag==0)&& (transperent_mode==0))
						{
							GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);	  //Default display
							GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
							GrContextForegroundSet(&sContext_Label, ClrWhite);
							GrStringDrawCentered(&sContext_Label,"   xxx.xx %  ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);	
						}
						else
						{
						//	GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);	  //Default display
						//	GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
						//	GrContextForegroundSet(&sContext_Label, ClrWhite);
						//	GrStringDrawCentered(&sContext_Label,"     HDLC     ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);	
						}
				break ;

				case First_Pulse_Received:	
							GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);	  //First_Pulse_Received
							GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
							GrContextForegroundSet(&sContext_Label, ClrWhite);
							if(decimal_position==1)
								GrStringDrawCentered(&sContext_Label,"   ---.- %  ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);	
							if(decimal_position==2)
								GrStringDrawCentered(&sContext_Label,"   --.-- %  ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);		   //15	// previous value 23
							if(decimal_position==3)
								GrStringDrawCentered(&sContext_Label,"   -.--- %  ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);		   //15	// previous value 23
							if(decimal_position==4)
								GrStringDrawCentered(&sContext_Label,"   -.---- %  ", -1,GrContextDpyWidthGet(&sContext_Label) / 2,153 , 1);		   //15	// previous value 23

				break ;

				case Clean_Display:
							
							if((once_display_hdlc==0)&&(transperent_mode==0))
							{
								sRect_Label.i16XMin = 0;
							    sRect_Label.i16YMin = 130;					// Clean Display
							    sRect_Label.i16XMax = 314;
							    sRect_Label.i16YMax = 180; 
							   	GrContextForegroundSet(&sContext_Label, BACKGROUND_COLOR);
							    GrRectFill(&sContext_Label, &sRect_Label);
								Error_Display_Seq++;
							}

							
			//	break;						
				
				case Error_Display:										
							i=0;
							memset(error_buff,'\0',sizeof(error_buff));
							memset(C_error_buff,'\0',sizeof(C_error_buff)); 
						
							GrContextBackgroundSet(&sContext_Label, BACKGROUND_COLOR);
							GrContextFontSet(&sContext_Label, &g_sFontCmss44b);
							GrContextForegroundSet(&sContext_Label, ClrWhite);
							
							value_trancation(decimal_position);
						
							if(Higher_error_flag==0)
							{
								memset(error_buff,'\0',sizeof(error_buff));
								if(decimal_position==1)			sprintf(error_buff, "%.1f", final_error);
								else if(decimal_position==2)	sprintf(error_buff, "%.2f", final_error);
								else if(decimal_position==3)	sprintf(error_buff, "%.3f", final_error);
								else if(decimal_position==4)	sprintf(error_buff, "%.4f", final_error); 
							}
							else
							{
								memset(error_buff,'\0',sizeof(error_buff));
								error_buff[0]=' ';error_buff[1]='H';error_buff[2]='H';error_buff[3]='H';
								error_buff[4]='H';
						    }
						
							
							if(Higher_error_flag==0)
							{
								while(error_buff[i]!=NULL)
								i++;
								error_buff[i]='%';		 
							}
					
							if((once_display_hdlc==0)&&(transperent_mode==0))
							GrStringDrawCentered(&sContext_Label,error_buff,-1,GrContextDpyWidthGet(&sContext_Label) /2,153, 1);		   //15	// previous value 23
							
							if(Measuremnt_flag==1)
							{	
								//single_meas=1;
								stop_measurement_flag=1;
								Measuremnt_flag=0;
							}
							if(reset_flag)
							{
								if(reset_count_flag==0)
								{
									reset_flag=0;
									Error_Display_Seq=1;
									start_measurement_flag=1;
									start_measurment();
								}
							}
						
				break;

			
			}
			last_Error_Display_Seq = Error_Display_Seq;
	}
		 
  	
	
	    
  	if(stop_measurement_flag)
   	{
	 	stop_measurement_flag=0;
	//	ROM_TimerDisable(TIMER2_BASE, TIMER_B);		  //Disable fout counter
	//	GPIOPinIntDisable(GPIO_PORTE_BASE, GPIO_PIN_4);	 //Enable the Individual Pin sensing intrrupt
		pulse_received=0;										

	} 
//	
		
}


/*************************************************/
/* Formual- Error calcualion                     */
/*************************************************/
void calculate_error(void )
{
   	if (N_Actual==0)
	{
		error_calc = 100;   
	}
	else
	{
		error_calc = (((N_Must - N_Actual)/N_Actual) * 100) ;//+ 0.05	  ;	 //Error in percentage


	}
}


void single_measurement(void)
{
 	register unsigned int x1,y1,w;

	//	ROM_TimerDisable(TIMER2_BASE, TIMER_B);		  //Disable fout counter
			
		GrContextForegroundSet(&sContext_Label, ClrWhite);
		x1=222,y1=44,w=10;	  
		for (x=0;x<=w ;x++)
		{
			for (i=x1-x;i<=x1+x;i++)
			{
				GrPixelDraw(&sContext_Label, y1-x, i );
			}
		}
			 
//		ROM_TimerDisable(TIMER2_BASE, TIMER_B);		  //Disable fout counter

			
		Flag.Pulse_Received = 0;

			
		GrContextForegroundSet(&sContext_Label, ClrWhite);
		x1=222,y1=44,w=10;	  
		for (x=0;x<=w ;x++)
		{
			for (i=x1-x;i<=x1+x;i++)
			{
				GrPixelDraw(&sContext_Label, y1-x, i );
			}
		}
		GrContextForegroundSet(&sContext_Label, ClrRed);	 
		sRect_Label.i16XMin = 110;
	    sRect_Label.i16YMin = 214;
	    sRect_Label.i16XMax = 130;
	    sRect_Label.i16YMax = 230;
	    GrRectFill(&sContext_Label, &sRect_Label);
}


void value_trancation(unsigned char decimal_position)
{
  	unsigned char err_count;
	double error_calc_copy;			

		if(error_calc<0)
			error_calc_copy=-error_calc;
		else
			error_calc_copy=error_calc;
	


			switch(decimal_position)
			{
				case 1:
						if(error_calc_copy>999.9)
						{
							Higher_error_flag=1;
						}
						else
						{
							error_value=error_calc*10;
							Copy_error_calc=error_calc*10;
							Higher_error_flag=0;
						}
				break;
				
				case 2: 
						if(error_calc_copy>99.99)
						{
							Higher_error_flag=1;
						}
						else
						{
							error_value=error_calc*100;
							Copy_error_calc=error_calc*100;
							Higher_error_flag=0;
						}
				break;
			 
				case 3: 
						if(error_calc_copy>9.999)
						{
							Higher_error_flag=1;
						}
						else
						{
							error_value=error_calc*1000;
							Copy_error_calc=error_calc*1000;
							Higher_error_flag=0;
						}
				break;	
			
				case 4:
						if(error_calc_copy>.9999)
						{
							Higher_error_flag=1;
						}
						else
						{
							error_value=error_calc*10000;
							Copy_error_calc=error_calc*10000;
							Higher_error_flag=0;
						}				
				break;
			}

			
			if(Higher_error_flag==0)
			{
				
				

				if(decimal_position==1) final_error=(float)error_value/10;
				else if(decimal_position==2) final_error=(float)error_value/100;
				else if(decimal_position==3) final_error=(float)error_value/1000;
				else if(decimal_position==4) final_error=(float)error_value/10000;
		
				err_count=3;
				while(Copy_error_calc)
				{
					C_error_buff[err_count--]=Copy_error_calc%10;
					Copy_error_calc=Copy_error_calc/10;
				}

			}

} 

void start_measurment(void)
{
	start_measurement_flag=0;
	//Pulse_sense_interrupt();
	 
	zero_flag=1;
	timer_start_flag=0;

	Flag.Error_Displyed_Once=0;
	Edge_count=0;
	C_Edge_count=0;
	pulse_count=0;

}

void Timer2_start(void)
{
  // TimerLoadSet(TIMER2_BASE, TIMER_B, 0xffff);
  // TimerMatchSet(TIMER2_BASE, TIMER_B, 0x0000);
  // ROM_TimerEnable(TIMER2_BASE, TIMER_B); 		  //Enable fout counter
  // IntEnable(INT_TIMER2B);
   fout_intCount=0;
}



 
 
 
