//*****************************************************************************
//				  
// macro.h 
//
// Project Name - Error Calculator
// Company Name- Zera India Private Limited.  
// Author - Rajesh Varma
// Date - 04/09/2017
// Revision - 0
//
// Remarks
//
//*****************************************************************************

//#include "grlib/grlib.h"
//#include "drivers/kitronix320x240x16_ssd2119_8bit.h"


#ifndef __macro_H
#define __macro_H


// The position and size of the box used to display the simple animation.
//
//*****************************************************************************
#define ANIM_TOP			180
#define ANIM_HEIGHT         20
#define ANIM_LEFT			40
#define ANIM_WIDTH			(320 - (2 * ANIM_LEFT))
#define ANIM_TOP_ERROR		158 

//*****************************************************************************
//
// The RGB value we use to change the color each time the animated bar cycles
// back to the start.
//
//*****************************************************************************
#define COLOR_INCREMENT		0x00306040


#define BACKGROUND_COLOR	ClrDarkBlue//ClrDarkBlue//ClrDarkBlue//ClrBlack//ClrWhite//ClrGainsboro//ClrLightCyan //ClrPowderBlue //ClrAliceBlue  //ClrLightBlue//ClrLightCyan
#define HIGHLIGHT           ClrGainsboro//ClrGreenYellow//ClrLemonChiffon//ClrOldLace//ClrKhaki//ClrLightGoldenrodYellow//ClrGreenYellow



/////////////////////////Flash LOCATIONS///////////////////////////////////////


#define SECTOR_SIZE							0xFFF
#define BLOCK_SIZE						    0xFFFF
#define CHIP_SIZE							0xFFFFF
#define INDX								1
#define LOC0								0
#define LOC1								1
#define LOC2								2
#define LOC3								3
#define LOC4								4
#define LOC5								5
#define LOC6								6
#define LOC7								7
#define LOC8								8
#define LOC9								9
#define LOC10								10


#define Row_0_Pin	GPIO_PIN_7		
#define Row_1_Pin	GPIO_PIN_0
#define Row_2_Pin	GPIO_PIN_7
#define Row_3_Pin	GPIO_PIN_1
#define Row_4_Pin	GPIO_PIN_2

#define Row_0_Base	GPIO_PORTE_BASE		
#define Row_1_Base	GPIO_PORTF_BASE
#define Row_2_Base	GPIO_PORTJ_BASE
#define Row_3_Base	GPIO_PORTF_BASE
#define Row_4_Base	GPIO_PORTF_BASE
//*****************************************************************************
//
// GPIO for the Parallel to serial conveter
//
//*****************************************************************************
#define PS_SD_PERIPH       SYSCTL_PERIPH_GPIOF
#define PS_SD_BASE         GPIO_PORTF_BASE
#define PS_SD_PIN          GPIO_PIN_0

#define PS_CLK_PERIPH      SYSCTL_PERIPH_GPIOJ
//#define PS_CLK_BASE        GPIO_PORTJ_BASE
#define PS_CLK_PIN         GPIO_PIN_7

#define PS_DATA_PERIPH     SYSCTL_PERIPH_GPIOF
#define PS_DATA_BASE       GPIO_PORTF_BASE
#define PS_DATA_PIN        GPIO_PIN_1


//*****************************************************************************
//
// GPIO for the serial to parallel converter .
//
//*****************************************************************************

#define SP_ST_PERIPH       SYSCTL_PERIPH_GPIOA
#define SP_ST_BASE         GPIO_PORTA_BASE
#define SP_ST_PIN          GPIO_PIN_3

#define SP_CLK_PERIPH      SYSCTL_PERIPH_GPIOA
#define SP_CLK_BASE        GPIO_PORTA_BASE
#define SP_CLK_PIN         GPIO_PIN_7

#define SP_DATA_PERIPH     SYSCTL_PERIPH_GPIOA
#define SP_DATA_BASE       GPIO_PORTA_BASE
#define SP_DATA_PIN        GPIO_PIN_6

 //*******************************************************************
 //
 //  Screen Numbers
 //
 //*********************************************************************



#define MAX_LOG				1000
#define BYTE_PER_LOG		512
#define LOG_PER_BLOCK		8

#define DATABASE_START_ADD	0x001000
#define BYTES_PER_BLOCK		(BYTE_PER_LOG * LOG_PER_BLOCK)
#define DATA_LENGTH			4//123//163//140//116




//#define Start_Button_Pressed			1
#define First_Pulse_Received			1
#define Clean_Display			 		2
#define Error_Display			    	3
#define Range_Changed 					5

#define Edit_Key 							GPIO_PIN_3
#define Edit_Key_P	    			GPIO_PORTN_BASE	
#define Position_Select_Key		GPIO_PIN_5
#define Select_Key_P	  		  GPIO_PORTE_BASE	

#define SC_PULSE_Key 							GPIO_PIN_1
#define SC_PULSE_Key_P	    			GPIO_PORTP_BASE	
#define Reset_Key									GPIO_PIN_1
#define Reset_Key_P	  		  			GPIO_PORTP_BASE	


#define Slave_ID_MSB		'0'
#define Slave_ID_LSB		'1'

#define MEASUREMENT_OFF			'0'
#define MEASUREMENT_RELASED		'1'
#define MEASUREMENT_STARTED		'2'
#define MEASUREMENT_COMPLETED	'3'
#define SIZE	5000

#define HARDWARE_VER   2.60
#define SOFTWARE_VER   2.65
 



				



#endif


